import { Data } from './index';
import { Value } from '../../action/Choice';
import Fields, { BaseProps } from '../../../_base/service/fields';
import Request from '../../../app/request';
import ObArray from '../../../app/datatype/obArray';

interface Props extends BaseProps<Value[]> {
  request: Request;
  /** 渲染的数据 */
  data: Data[];
}

class Choice extends Fields<Value[]> {
  constructor(props: Props) {
    super(props);

    this.data = new ObArray(props.request, props.data);

    this.setData = this.setData.bind(this);
  }

  public readonly data: ObArray<Data>;

  public setData(data: Data[]): void {
    this.data.set(data);
  }
}

export default Choice;