import * as React from 'react';
import IconText, { Props as IconTextProps } from '../IconText';
import Container, { Props as ContainerProps } from '../../../component/Container';

interface Props extends ContainerProps, IconTextProps {
  onClick: (e: React.MouseEvent<HTMLDivElement>, text: string) => void;
}

// const prefixCls = 'yj-component-tab';
const TabItem = (props: Props) => {
  return (
    <Container
      {...props}
      onClick={(e) => {
        if (props.onClick) {
          props.onClick(e, props.text);
        }
      }}
    >
      <IconText {...props} />
    </Container>
  );
};

export default TabItem;