import { observable, action } from 'mobx';
import Request from '../request';
import Base from '../../_base/datatype';

class ObArray<Value> extends Base {
  constructor(request: Request, value?: Array<Value>) {
    super(request);

    this.value = value || [];
  }

  @observable protected value: Array<Value>;

  @action public set(value: Array<Value>): void {
    if (value.length > 0) {
      this.request.setState('complete');
    } else {
      this.request.setState('empty');
    }

    this.value = value;
  }

  public get(): Array<Value> {
    return this.value;
  }
}

export default ObArray;