import { observable, action } from 'mobx';
import Request from '../request';
import Base from '../../_base/datatype';
import wx, { Share } from '../weixin';
const isEmpty = require('lodash/isEmpty');

type Detail<T> = T & Share;

class ObArray<Key, Value> extends Base {
  constructor(request: Request) {
    super(request);
  }

  @observable protected value: Map<Key, Detail<Value>> = new Map();

  @action public set(key: Key, value: Detail<Value>): void {
    // 微信分享
    wx.onShare({
      title: value.title,
      desc: value.desc,
      imgUrl: value.cover
    });

    if (isEmpty(value)) {
      this.request.setState('empty');
    } else {
      this.request.setState('complete');
    }

    this.value.set(this.stringify(key), value);
  }

  public get(key: Key): Detail<Value> | undefined {
    return this.value.get(this.stringify(key));
  }
}

export default ObArray;