import yj from '../../typings';
import * as React from 'react';
import * as classNames from 'classnames';

interface Props extends yj.ComponentProps {
  /** 点的个数 */
  count: number;
  /** 激活的索引 */
  activeIndex: number;
}

const prefixCls = 'yj-component-carousel-dot';

const Dots = (props: Props) => {
  const { className, style, count, activeIndex } = props;
  const item: JSX.Element[] = [];

  for (let i = 0; i < count; i++) {
    item.push(
      <div
        key={i}
        className={classNames(`${prefixCls}-item`, {
          [`${prefixCls}-item-active`]: activeIndex === i
        })}
      />
    );
  }

  return (
    <div
      className={classNames(prefixCls, className)}
      style={style}
    >
      {item}
    </div>
  );
};

export default Dots;