import _yj from '../../typings/index';
import * as React from 'react';
import Icon from '../Icon';
import Toast from '../Toast';
import svgRootPath from '../../utils/svgRootPath';
const svgFile = {
  prompt: svgRootPath + require('../../assets/prompt.svg').id,
};

export interface Base {
  /** 是否开启提示文字 */
  prompt?: boolean;
  /** 提示文字 */
  promptText?: string;
  /** 是否错误 */
  error?: boolean;
}

export interface Props extends _yj.ComponentProps, Base {
  children?: any;
}

const prefixCls = 'yj-component-formitem';
class After extends React.PureComponent<Props> {
  constructor(props: Props) {
    super(props);
  }

  public static displayName: string = 'After';

  public onPrompt = () => {
    if (this.props.prompt) {
      Toast.show(this.props.promptText || '');
    }
  }

  public promptRender(): JSX.Element {
    const { error } = this.props;
    return (
      <Icon
        className={`${prefixCls}-prompt`}
        src={svgFile.prompt}
        onClick={this.onPrompt}
        style={{
          display: error === true ? 'block' : 'none'
        }}
      />
    );
  }

  public render(): JSX.Element {
    const { prompt, children } = this.props;
    let render;

    if (children) {
      render = children;
    } else if (prompt) {
      render = this.promptRender();
    }

    return render;
  }
}

export default After;