import yj from '../../typings';
import * as React from 'react';
import * as classNames from 'classnames';

interface Props extends yj.ComponentProps {
  children: JSX.Element | string;
  value: string;
  rowSpan?: number;
}

const prefixCls = 'yj-component-Keyboard-item';
const KeyboardItem = (props: Props) => {
  const { className, children, value, rowSpan, style } = props;

  return (
    <td
      className={classNames(prefixCls, className)}
      rowSpan={rowSpan}
      style={style}
      data-key={value}
    >
      {children}
    </td>
  );
};

export default KeyboardItem;