import * as React from 'react';
import * as className from 'classnames';
import Icon from '../../Icon';
import Container from '../../Container';
import svgRootPath from '../../../utils/svgRootPath';
import { ChildrenProps } from '../index';
import './index.scss';
const svgFile = {
  minus: svgRootPath + require('../../../assets/minus.svg').id,
  plus: svgRootPath + require('../../../assets/plus.svg').id,
};

interface Props extends ChildrenProps {
}

const prefixCls = 'yj-component-map-control';
class Zoom extends React.PureComponent<Props> {
  constructor(props: Props) {
    super(props);

    this.onClick = this.onClick;
  }

  private onClick(type: string): void {
    const { map } = this.props;

    if (map) {
      if (type === 'minus') {
        map.zoomOut();
      } else {
        map.zoomIn();
      }
    }
  }

  public render(): JSX.Element[] {
    return ['minus', 'plus'].map((item) => (
      <Container
        className={`${prefixCls}-item`}
        alignItems="center"
        justifyContent="center"
        key={item}
        onClick={() => this.onClick(item)}
      >
        <Icon
          className={className(`${prefixCls}-svg`, `${prefixCls}-zoom`)}
          src={svgFile[item as 'minus' | 'plus']}
        />
      </Container>
    ));
  }
}

export default Zoom;
