import * as React from 'react';
import * as classNames from 'classnames';
import Container from '../../Container';
import Zoom from './Zoom';
import Return, { Props as ReturnProps } from './Return';
import './index.scss';

interface Props extends ReturnProps {
  children?: JSX.Element[] | JSX.Element;
}

interface ItemProps {
  className?: string;
  children?: JSX.Element;
}

const prefixCls = 'yj-component-map-control';
const Control = (props: Props) => {
  const { children, map } = props;

  return (
    <div className={prefixCls}>
      <Zoom map={map} />
      <Return {...props} map={map} />
      {children}
    </div>
  );
};

const Item = (props: ItemProps) => {
  const { children, className } = props;

  return (
    <Container
      className={classNames(`${prefixCls}-item`, className)}
      alignItems="center"
      justifyContent="center"
    >
      {children}
    </Container>
  );
};

export { Control, Item };
