import * as React from 'react';
import * as classNames from 'classnames';
import { View } from './index';

const prefixCls = 'yj-component-popup';
class Button extends React.Component<View> {
  constructor(props: View) {
    super(props);

    this.onDisabled = this.onDisabled.bind(this);
  }

  public static displayName: string = 'PopupButton';

  private onDisabled(e: any): void {
    e.preventDefault();
    e.stopPropagation();
  }

  public render(): any {
    const { disabled, onClick, className, children } = this.props;

    return (
      <div
        className={classNames(className, {
          [`${prefixCls}-disabled`]: disabled
        })}
        onClick={onClick}
        onPaste={this.onDisabled}
        onContextMenu={this.onDisabled}
        onCopy={this.onDisabled}
        onCut={this.onDisabled}
      >
        {children}
      </div>
    );
  }
}

export default Button;