import yj from '../../../typings';
import * as React from 'react';
import * as classNames from 'classnames';
import './index.scss';

export interface Props extends yj.ComponentProps  {
  size?: number;
  backgroundColor?: string;
  activeColor?: string;
}

const prefixCls = 'yj-component-loading';
const Loading = (props: Props) => {
  return (
    <div className={prefixCls}>
      <div
        className={classNames({
          [`${prefixCls}-cirle`]: true,
          [props.className || '']: !!props.className
        })}
        style={{
          borderWidth: props.size || 10,
          borderTopColor: props.backgroundColor || '#ccc',
          borderBottomColor: props.backgroundColor || '#ccc',
          borderRightColor: props.backgroundColor || '#ccc',
          borderLeftColor: props.activeColor || '#108ee9',
          ...props.style
        }}
      >
        <div className={`${prefixCls}-placeholder`} />
      </div>
    </div>
  );
};

export default Loading;