import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import isSvgFile from '../../utils/isSvgFile';
import Container from '../Container';
import './index.scss';

export interface Props {
  icon: string;
  iconCls?: string;
  uploadCls?: string;
}

const prefixCls = 'yj-component-uploadimg-upload';

const Upload = (props: Props) => {
  const { icon, iconCls, uploadCls } = props;
  return (
    <Container
      className={classNames(prefixCls, uploadCls)}
      alignItems="center"
      justifyContent="center"
    >
      {isSvgFile(icon) ? (
        <Icon className={iconCls} src={icon} />
      ) : (
        <img className={iconCls} src={icon} />
      )}
    </Container>
  );
};

export default Upload;