import Request, { Props, Event } from '../../app/request';
import Service, { ExtendsRequestProps } from './index';
import Toast from '../../component/Toast';

export interface Params extends Event {
}

class Post extends Request {
  constructor(service: Service, props: Props & ExtendsRequestProps) {
    super(props);

    this.service = service;
  }

  private service: Service;
  /** 发送请求 */
  public async send(params?: Params): Promise<void> {
    this.action({
      config: {
        url: this._api,
        method: 'post',
        data: this.requestData && this.requestData()
      }
    }).then((response) => {
      if (response.retCode === '0000') {

        if (this._callback) {
          this._callback(response);
        }

        if (params && params.callback) {
          params.callback(response);
        }

        this.service._setData(response.result);
      } else {
        Toast.show(response.retMsg);
      }
    }).catch((err) => {
      console.error(err);
      if (this._failback) {
        this._failback(err);
      }

      if (params && params.failback) {
        params.failback(err);
      }
    });
  }
}

export default Post;
