import Behavior from './index';

interface Params {
  behavior: Behavior;
  /** 路由动作类型 */
  type: 'enter' | 'exit';
  /** 当前页面 */
  now: string;
  /** 前往的页面 */
  to: string;
  /** 停留时间 */
  staytime: number;
}

let prevPageName: string = '外部入口';

/** 页面离开的行为 */
export default function pageLeave(params: Params): void {
  const { behavior, type, now, to, staytime } = params;
  const pageName = type === 'enter' ? now : to;
  const actionName = type === 'enter' ? '进入-' + to : '后退-' + now;

  behavior.trigger({
    pageName,
    actionName,
    detailedData: {
      form: prevPageName
    },
    stopSeconds: staytime
  });

  prevPageName = type === 'enter' ? now : to;
}