import Request, { Event } from '../../app/request';
import Service from './index';
const isEmpty = require('lodash/isEmpty');

// interface Data {
//   [key: string]: Action[];
// }

interface Params extends Event {
}

class Post extends Request {
  constructor(service: Service) {
    super();

    this.service = service;
  }

  private service: Service;

  /** 发送请求 */
  public async send(params?: Params): Promise<void> {
    if (!Service.options) {
      return;
    }
    const { api, account } = Service.options;

    if (api && account && account.data) {
      const { openId, memberId } = account.data;
      const sendData: any = {};

      if (openId || memberId) {
        if (openId) {
          sendData.openId = openId;
        }
        if (memberId) {
          sendData.memberId = memberId;
        }

        if (isEmpty(this.service.actions) === false) {
          this.action({
            config: {
              url: api,
              method: 'post',
              data: {
                ...sendData,
                dataStr: JSON.stringify({
                  page: this.service.actions
                }),
              }
            }
          }).then((response) => {
            if (params && params.callback) {
              params.callback(response);
            }
          });
        }
      } else {
        console.warn('行为记录发送失败，缺少openId或memberId');
      }
    } else if (api) {
      console.warn('行为记录发送失败，缺少account或account.data参数');
    }

    this.service.actions = [];
  }
}

export default Post;
