/// <reference path="./module.d.ts" />
/// <reference path="./lodash/index.d.ts" />

import { RouteComponentProps } from 'react-router';
import { Location } from 'history';
// import Behavior, { LoggerItem, TriggerParams } from '../model/behavior';
// import { WithStack } from '../component/PageStack/WithStack';

declare namespace YueJia {

  type RequestStatus = 'start' | 'end' | undefined;
  type OnClick<T> = (e: React.MouseEvent<T>, ...args: any[]) => void;
  
  interface PageProps<Match>  {
    match: RouteComponentProps<Match>['match'];
    location: Location;
    // behavior: Behavior;
  }
  
  interface ComponentProps {
    className?: string;
    id?: string;
    style?: React.CSSProperties;
    datatype?: string;
  }

  /** 请求响应 */
  interface response {
    retCode: string;
    result: any;
    retMsg: string;
  }

  // interface ComponentBehavior {
  //   /** 实例化的行为记录对象，一般从页面的props中得到 */
  //   behavior?: Behavior;
  //   /** 行为记录的动作 */
  //   behaviorAction?: LoggerItem;
  //   /** 行为记录的数据 */
  //   behaviorData?: TriggerParams['detailedData'];
  // }

  interface ChildType {
    displayName: string;
  }
}

export default YueJia;