/**
 * 日期模式
 * 参考：https://www.zhihu.com/question/23730083
 */
export type Mode = (
  'ss' | 'mm' | 'HH' | 'dd' | 'MM' | 'yy' |
  'mmss' | 'HHmmss' | 'ddHHmmss' | 'MMddHHmmss' | 'yyMMddHHmmss' |
  'yyMM' | 'yyMMdd' | 'yyMMddHH' | 'yyMMddHHmm'
);

// todo mode类型要改
export default function dateToStringArr(date: string | number | Date, mode: Mode): string[] {
  const type = typeof date;
  const NewDate: Date = type === 'string' || type === 'number' ? new Date(date as string) : date as Date;
  const year = NewDate.getFullYear().toString();
  const month = NewDate.getMonth().toString();
  const day = NewDate.getDate().toString();
  const hours = NewDate.getHours().toString();
  const min = NewDate.getMinutes().toString();
  const sec = NewDate.getSeconds().toString();
  const data = [];

  if (mode.indexOf('yy') >= 0) {
    data.push(year);
  }
  if (mode.indexOf('MM') >= 0) {
    data.push(month);
  }
  if (mode.indexOf('dd') >= 0) {
    data.push(day);
  }
  if (mode.indexOf('HH') >= 0) {
    data.push(hours);
  }
  if (mode.indexOf('mm') >= 0) {
    data.push(min);
  }
  if (mode.indexOf('ss') >= 0) {
    data.push(sec);
  }

  return data;
  // switch (mode) {
  //   case 'ss':
  //     return [sec];
  //   case 'mm':
  //     return [min];
  //   case 'HH':
  //     return [hours];
  //   case 'dd':
  //     return [day];
  //   case 'MM':
  //     return [month];
  //   case 'yy':
  //     return [year];
  //   case 'mmss':
  //     return [min, sec];
  //   case 'HHmmss':
  //     return [hours, min, sec];
  //   case 'ddHHmmss':
  //     return [day, hours, min, sec];
  //   case 'MMddHHmmss':
  //     return [month, day, hours, min, sec];
  //   case 'yyMMddHHmmss':
  //     return [year, month, day, hours, min, sec];
  //   case 'yyMM'
  //   default:
  //     return [];
  // }
}