import leftPad from './leftPad';
import dateToStringArr, { Mode } from './dateToStringArr';

function toStr(value: string): string {
  return leftPad(parseInt(value));
}

/** 字符串数组转字符串  */
export default function dateformat(date: string | number | Date | string[], mode: Mode): string {
  const tempArr = date as string[];
  let dateArr: string[] = [];

  if (tempArr.slice) {
    const sliceArr = tempArr.slice();
    dateArr = Array.isArray(sliceArr) ? sliceArr : dateToStringArr(date as Date, mode);
  } else {
    dateArr = dateToStringArr(date as Date, mode);
  }

  const dateArrLengh = dateArr.length;
  const month = leftPad(parseInt(dateArr[1]) + 1);
  const day = toStr(dateArr[2]);

  switch (dateArrLengh) {
    case 1:
      return dateArr[0];
    case 2:
      return `${dateArr[0]}-${month}`;
    case 3:
      return `${dateArr[0]}-${month}-${day}`;
    case 4:
      return `${dateArr[0]}-${month}-${day} ${toStr(dateArr[3])}`;
    case 5:
      return `${dateArr[0]}-${month}-${day} ${toStr(dateArr[3])}:${toStr(dateArr[4])}`;
    case 6:
      return `${dateArr[0]}-${month}-${day} ${toStr(dateArr[3])}:${toStr(dateArr[4])}:${toStr(dateArr[5])}`;
    default:
      return '';
  }
}