import dateAdd from './dateAdd';

/**
 * 日期范围转日期数组
 * @param minDate 最小日期
 * @param maxDate 最大日期
 */
export default function rangeDateToDates(minDate: Date, maxDate: Date): Date[] {
  // 最小值的年份
  const minYear = minDate.getFullYear();
  // 最大值的年份
  const maxYear = maxDate.getFullYear();
  // 最小值的月份
  const minMonth = minDate.getMonth();
  // 最大值的月份
  const maxMonth = maxDate.getMonth();
  // 月数差值
  const diff = (maxYear - minYear) * 12 + maxMonth - minMonth;
  // 存放要放回的date数组
  const dateArr: Date[] = [];
  // 用于临时存储要push到dateArr的变量
  let temp = minDate;

  for (let i = 0; i < diff; i++) {
    // 每次新增一月
    temp = dateAdd(temp, 1, 'months');
    dateArr.push(temp);
  }

  return dateArr;
}