import * as React from 'react';
import matchPath from './matchPath';
import Page from '../app/page';

export interface Props {
  component: typeof Page;
  exact: boolean;
  path: string;
}

export default function switchRouter(routes: JSX.Element[], pathname: string): React.ReactElement<Props> | null {
  let match: any;
  let child!: React.ReactElement<any>;

  React.Children.forEach(routes, (element) => {
    if (match == null && React.isValidElement(element)) {
      const {
        path: pathProp,
        exact,
        strict,
        sensitive,
        from
      }: any = element.props;
      const path = pathProp || from;

      child = element;
      match = path ? matchPath(pathname, { path, exact, strict, sensitive }) : null;
    }
  });

  return match ? child : null;
}