/** 蔡勒公式 */
export default function zellerFormula(date: Date): number {
  const year = date.getFullYear();
  const month = date.getMonth();
  const day = date.getDate();
  let yearString = year.toString();
  let m = month + 1;

  if (m < 3) {
    m += 12;
    yearString = (year - 1).toString();
  }

  const c = parseInt(yearString.substr(0, 2));
  const y = parseInt(yearString.substr(2, 3));
  // tslint:disable-next-line:max-line-length
  const result = parseInt((y + y / 4).toString()) + parseInt((c / 4).toString()) - 2 * c + parseInt((26 * (m + 1) / 10).toString()) + day - 1;

  return (result % 7 + 7) % 7;
}